#Использовать asserts

#Область ОписаниеПеременных

// Сценарий - класс, содержащий указанный метод завязи.
Перем _Родитель;

// Строка - Имя метода, которым можно создать жёлудь.
Перем _ИмяМетода;

// Структура - данные метода, как из возвращает рефлектор:
Перем _ДанныеМетода;

// Действие - делегат, который можно вызвать, чтобы создать жёлудь.
Перем _Действие;

// Булево - флаг, что делегат ведет на конструктор класса, а не на &Завязь-метод.
Перем _ЭтоКонструктор;

#КонецОбласти

#Область ПубличныйПрограммныйИнтерфейс

// Класс, содержащий указанный метод завязи.
//
//  Возвращаемое значение:
//   Сценарий
//
Функция Родитель() Экспорт
	Возврат _Родитель;
КонецФункции

// Имя метода, которым можно создать жёлудь.
//
//  Возвращаемое значение:
//   Строка
//
Функция ИмяМетода() Экспорт
	Возврат _ИмяМетода;
КонецФункции

// Данные метода, как из возвращает рефлектор.
//
//  Возвращаемое значение:
//   Структура
//
Функция ДанныеМетода() Экспорт
	Возврат _ДанныеМетода;
КонецФункции

// Делегат, который можно вызвать, чтобы создать жёлудь.
//
//  Возвращаемое значение:
//   Действие
//
Функция Действие() Экспорт
	Возврат _Действие;
КонецФункции

// Флаг, что делегат ведет на конструктор класса, а не на &Завязь-метод.
//
//  Возвращаемое значение:
//   Булево
//
Функция ЭтоКонструктор() Экспорт
	Возврат _ЭтоКонструктор;
КонецФункции

#КонецОбласти

#Область Инициализация

// Дата-класс для хранения данных о способе создания жёлудя.
//
// Параметры:
//   Родитель - Сценарий - Класс, содержащий указанный метод завязи.
//   ИмяМетода - Строка - Имя метода, которым можно создать жёлудь.
//   ДанныеМетода - Структура - Данные метода, как из возвращает рефлектор.
//   Действие - Действие - Делегат, который можно вызвать, чтобы создать жёлудь.
//   ЭтоКонструктор - Булево - Флаг, что делегат ведет на конструктор класса, а не на &Завязь-метод.
//
Процедура ПриСозданииОбъекта(Родитель, ИмяМетода, ДанныеМетода, Действие, ЭтоКонструктор)
	Ожидаем.Что(Родитель).ИмеетТип("Строка");
	Ожидаем.Что(ИмяМетода).ИмеетТип("Строка");
	Ожидаем.Что(ДанныеМетода).ИмеетТип("СтрокаТаблицыЗначений");
	Ожидаем.Что(Действие).ИмеетТип("Действие");
	Ожидаем.Что(ЭтоКонструктор).ИмеетТип("Булево");

	_Родитель = Родитель;
	_ИмяМетода = ИмяМетода;
	_ДанныеМетода = ДанныеМетода;
	_Действие = Действие;
	_ЭтоКонструктор = ЭтоКонструктор;
КонецПроцедуры

#КонецОбласти
